/* $Id$ */

module d07.main;

private import ddddd.ddddd;
private import jcode;
private import denzi_image2;
private import std.random;
private import std.string;
private import std.math;

private import std.c.windows.windows;


/* TODO: キーは取りこぼしが起こらないように、イベントを設定して、
         そこからキューに溜め込むようにする必要がある */

/* TODO: とりあえず、まず、起動する状態に持っていく事。
 *       細かい部分は、その後で。
 *

/* TODO: 多重起動の禁止(どうやって実装する？Win32API？)
 * TODO: iniファイルに簡単な設定を保存(パスワード以外)
 * TODO: 今は全部SDL_SWSURFACEでやってるが、あとで、簡単に、
 *       SDL_HWSURFACEに変更できるような仕組みが欲しい
 */


// ゲーム用フラグ類(すごい適当な実装)
static bool started = false;
static int hp = 20;
static int arch_hp = 5;
static int door_event = 0;
static int sunk = 0; // 1=柱, 2=アーチ
static int sunk_level = 0;


const static byte[] rand2floorid = [ 1, 2, 7, 6, 8, 4, 3, 5, 9, 10, 11 ];
byte rand_floorid() {
  if (!(rand() % 2)) return rand2floorid[0];
  if (!(rand() % 3)) return rand2floorid[1];
  if (!(rand() % 4)) return rand2floorid[2];
  byte result = cast(byte)(rand() % 11);
  return rand2floorid[result];
}

/* 指定された配列を適当な床データで埋める。
   今のところは、以下のような構造で保持する。
   floormap[y][x] = [ imgtype, floorid ]
   但し、一番外側はnullにする(壁で囲む為)
 */

byte*[][] gen_floormap(int width, int height)
{
  byte*[][] floormap;
  floormap.length = height;
  for (int y = 0; y < height; y++) {
    floormap[y].length = width;
    for (int x = 0; x < width; x++) {
      byte floorid = cast(byte)((
            (x != 0)
            &&
            (x != (width-1))
            &&
            (y != 0)
            &&
            (y != (height-1))
            ) ? rand_floorid() : 0);
      if (floorid) {
        byte data[] = [ IMG_MISC, floorid ];
        floormap[y][x] = data.dup.ptr;
      }
      else {
        floormap[y][x] = null;
      }
    }
  }
  return floormap;
}

// クリア不能なマップになったら、nullを返す事
byte*[][] _gen_objmap(int width, int height)
{
  byte*[][] objmap;
  objmap.length = height;
  bool created_arch = false;
  for (int y = 0; y < height; y++) {
    objmap[y].length = width;
    for (int x = 0; x < width; x++) {
      // 今のところ、壁は周囲のみとする。
      // 内側は全て空間にする。
      if ((y != 0) && (y != (height-1)) && (x != 0) && (x != (width-1))) {
        objmap[y][x] = null;
        continue;
      }
      byte walltype = cast(byte)((rand() % 2) ? IMG_WALLS : IMG_PILLARS);
      byte wallid = 0;
      byte data[2];
      // 角四つを除去する
      if ((y == 0) && (x == 0)) {
        wallid = 6;
        data[] = [ walltype, wallid ]; objmap[y][x] = data.dup.ptr;
        continue;
      }
      else if ((y == 0) && (x == (width-1))) {
        wallid = 8;
        data[] = [ walltype, wallid ]; objmap[y][x] = data.dup.ptr;
        continue;
      }
      else if ((y == (height-1)) && (x == 0)) {
        wallid = 7;
        data[] = [ walltype, wallid ]; objmap[y][x] = data.dup.ptr;
        continue;
      }
      else if ((y == (height-1)) && (x == (width-1))) {
        wallid = 5;
        data[] = [ walltype, wallid ]; objmap[y][x] = data.dup.ptr;
        continue;
      }
      // 残るは上辺または両サイド。
      // 特殊壁にするかどうかを決定する
      if (rand() % 8) {
        // 通常壁だった。適当に設定する
        if ((y == 0) || (y == (height-1))) {
          wallid = 13; // 上辺下辺
        }
        else {
          wallid = 14; // 両サイド
        }
        data[] = [ walltype, wallid ]; objmap[y][x] = data.dup.ptr;
        continue;
      }
      // 特殊壁決定。
      walltype = IMG_DOORS;
      // どの特殊壁かを決定する
      // 0 = 開きドア通路
      // 1 = 閉じドア通路
      // 2 = ドア無し通路
      // 3 = アーチ(フラグ制約有り)
      // 4 = ヴィーの祭壇(向き制約有り)
      int type = rand() % 5;
      if (type == 0) {
        wallid = cast(byte)(((y == 0) || (y == (height-1))) ? 2 : 1);
      }
      else if (type == 1) {
        wallid = cast(byte)(((y == 0) || (y == (height-1))) ? 4 : 3);
      }
      else if (type == 2) {
        wallid = cast(byte)(((y == 0) || (y == (height-1))) ? 6 : 5);
      }
      else if (type == 3) {
        if (created_arch) {
          walltype = IMG_WALLS;
          wallid = cast(byte)(((y == 0) || (y == (height-1))) ? 13 : 14);
        }
        else {
          created_arch = true;
          wallid = cast(byte)(((y == 0) || (y == (height-1))) ? 7 : 8);
        }
      }
      else if (type == 4) {
        if (y == 0) {
          wallid = 10;
        }
        else if (x == 0) {
          wallid = 9;
        }
        else {
          walltype = IMG_WALLS;
          wallid = cast(byte)((y == (height-1)) ? 13 : 14);
        }
      }
      else { throw new Error("assertion"); }
      data[] = [ walltype, wallid ]; objmap[y][x] = data.dup.ptr;
      continue;
    }
  }
  // 最後に、アーチが生成されているかどうかをチェックする
  return created_arch ? objmap : null;
}
// 非nullが返ってくるまで_gen_objmap()を実行し続ける
byte*[][] gen_objmap(int width, int height)
{
  byte*[][] objmap;
  while (1) {
    objmap = _gen_objmap(width, height);
    if (objmap) break;
  }
  return objmap;
}




static const int QVMAP_PADDING = 80; // qvmapの上方向に持たせる余裕部分サイズ
static const int MAP_WIDTH = 12;
static const int MAP_HEIGHT = 12;

static int p_x = MAP_WIDTH/2;
static int p_y = MAP_HEIGHT/2;

int main_of_mains(char[][] args) {
  ddddd_init();

  ddddd_init_wm("サンタナとワムウとエシディシが", "data/images/icon.bmp", 0, 0);

  SDL_Surface *rw = ddddd_init_rw(320, 240);

  // BGM
  // TODO: 何らかのBGM保持クラスっぽいものを作る事
  Mix_Music *music = Mix_LoadMUS("data/sounds/mozart439b1-4.ogg");
  if (Mix_PlayMusic(music, -1) < 0) {
    throw new Error("failed bgm");
  }

  //ddddd_MessageBox("日本語");
  // 背景タイル画像
  SDL_Surface *di_tile[] = load_di("data/images");
  //DIInfo *di = get_rect_of_pillar(3);
  //SDL_BlitSurface(di_tile[di.type], di.rect, rw, null);

  // 今回は固定マップとする
  // 床マップを作成する
  byte*[][] floormap = gen_floormap(MAP_WIDTH*3, MAP_HEIGHT*3);
  // 立体物マップを作成する
  byte*[][] objmap = gen_objmap(MAP_WIDTH, MAP_HEIGHT);

  // スクロール用サーフィスを用意する
  int qv_size = ddddd_qv_rotate45_size(cast(void*[][])floormap);
  RGBAMask *m = ddddd_get_rgbamask();
  SDL_Surface *qvmap = SDL_CreateRGBSurface(SDL_SWSURFACE,
      (qv_size+1)*TILE_WIDTH/2,
      (qv_size+1)*TILE_HEIGHT/2 + QVMAP_PADDING, // 上方向には余裕が必要
      rw.format.BitsPerPixel, m.r, m.g, m.b, m.a);
  if (!qvmap) {
    throw new Error("failed qvmap");
  }

  // フォント読み込み
  //TTF_Font *font = TTF_OpenFont("data/fonts/aqua2_8/aquafont.ttf", 16);

  // タイマー
  // (ゲーム内での時間経過を示す。
  //  1ずつ進める必要はあるものの、必ずしも1ずつ表示する必要は無い)
  //int timer = 0; // 一時的に廃止
  // 移動用一時変数
  int prev_x = 0;
  int prev_y = 0;
  int prev_timer = 0;
  int move_x = 0;
  int move_y = 0;
  bool move_flag = false;
  bool overhalf = false;
  byte *collision = null;

  // キー状態を保存する変数(SDL_PollEventではキーの変化しか取れない為)
  int acc_x = 0;
  int acc_y = 0;
  // TODO: あとで
  // イベントループ
  bool done = false;
  SDL_Event e;
Loop:
  while ( !done ) {
    // 入力取得とデフォルトの挙動(今はalt+F4系のみ)
    while ( SDL_PollEvent(&e) ) done = e.type == SDL_QUIT;
    int numkeys;
    Uint8* keystate = SDL_GetKeyState(&numkeys);
    if (
        (keystate[SDLK_LALT] || keystate[SDLK_RALT])
        &&
        keystate[SDLK_F4]
       ) {
      done = true;
      break;
    }
    // キー取得と移動
    acc_x = 0;
    acc_y = 0;
    // 左要素
    if (keystate[SDLK_LEFT] || keystate[SDLK_h]
        || keystate[SDLK_y] || keystate[SDLK_b]
        || keystate[SDLK_KP1] || keystate[SDLK_KP4] || keystate[SDLK_KP7]) {
      acc_x -= 1;
    }
    // 右要素
    if (keystate[SDLK_RIGHT] || keystate[SDLK_l]
        || keystate[SDLK_u] || keystate[SDLK_n]
        || keystate[SDLK_KP3] || keystate[SDLK_KP6] || keystate[SDLK_KP9]) {
      acc_x += 1;
    }
    // 上要素
    if (keystate[SDLK_UP] || keystate[SDLK_k]
        || keystate[SDLK_y] || keystate[SDLK_u]
        || keystate[SDLK_KP7] || keystate[SDLK_KP8] || keystate[SDLK_KP9]) {
      acc_y -= 1;
    }
    // 下要素
    if (keystate[SDLK_DOWN] || keystate[SDLK_j]
        || keystate[SDLK_b] || keystate[SDLK_n]
        || keystate[SDLK_KP1] || keystate[SDLK_KP2] || keystate[SDLK_KP3]) {
      acc_y += 1;
    }
    // キー操作を反映させる
    if (!prev_timer && (acc_x || acc_y)) {
      overhalf = false;
      // 移動可能かどうかチェックする
      int tmp_x = acc_x;
      int tmp_y = acc_y;
      key_rotate45rev(&tmp_x, &tmp_y); // 見た目の方向を内部での方向に変換する
      byte *info = cast(byte*)peek_map(cast(void*[][])objmap, p_x+tmp_x, p_y+tmp_y);
      if (!info) {
        // 移動をプリセットする
        prev_x = acc_x;
        prev_y = acc_y;
        prev_timer = (acc_x && acc_y) ? TILE_HEIGHT/2*3 : TILE_HEIGHT*3;
        move_flag = true;
      }
      else {
        // 移動失敗をプリセットする
        prev_x = acc_x;
        prev_y = acc_y;
        collision = info;
        // 移動方向によって、prev_timerの値を変化させる必要がある
        // (今のところ、ドット数で記述している為)
        prev_timer = TILE_HEIGHT/2*3;
        if (acc_x && acc_y) {
          prev_timer /= 2;
          // 移動先が円柱なら、更に衝突位置を短くする
          if (info[0] == IMG_PILLARS) prev_timer = TILE_HEIGHT/2;
        }
        move_flag = false;
      }
    }
    // 移動を実行する
    if (prev_timer) {
      move_x += prev_x;
      move_y += prev_y;
      prev_timer--;
      // move_*が一定値を越えたら、overhalfを立て、進行度を減らす
      if (!overhalf && (
            (TILE_HEIGHT*3 <= abs(move_y))
            ||
            (TILE_WIDTH*3/2 <= abs(move_x)))) {
        overhalf = true;
        int adjust[] = adjust_overhalf(move_x, move_y);
        move_x -= TILE_HEIGHT*adjust[1];
        move_y -= TILE_HEIGHT*adjust[0];
      }
      if (!prev_timer) {
        if (move_flag) {
          // 見た目の方向を内部での方向に変換する
          key_rotate45rev(&prev_x, &prev_y);
          p_x += prev_x;
          p_y += prev_y;
          //ddddd_MessageBox("loc: "~toString(p_x)~", "~toString(p_y));
          //ddddd_MessageBox("prev: "~toString(prev_x)~", "~toString(prev_y));
        }
        else {
          // 衝突した。collisionに応じた処置が取られる。
          bool event_occurred = false;
          // まずHPを減らす
          hp--;
          // hpが0以下になったら死亡
          if (hp <= 0) {
            MessageBeep(-1); // 衝突SE
            // 沈みアニメを行う
            sunk = 1;
            for (int i = 0; i < 24; i++) {
              redraw(rw, objmap, floormap, di_tile, qvmap, move_x, move_y, overhalf);
              SDL_Flip(rw);
              SDL_Delay(5);
            }
            // TODO: 可能なら効果音を入れる事
            // エピローグを出す
            ddddd_MessageBox("その後、柱の姿を見た者は誰もいない……", "エピローグ");
            ddddd_MessageBox("END", "エピローグ");
            done = true;
            break;
          }
          // まだ生きてる
          if (collision[0] == IMG_DOORS) {
            event_occurred = true;
            // ドア/アーチイベント
            if ((collision[1] == 7) || (collision[1] == 8)) {
              // アーチ
              arch_hp--;
              switch (arch_hp) {
                case 4:
                  ddddd_MessageBox("何だよ、おい、何してんだよ", "アーチ");
                  break;
                case 3:
                  ddddd_MessageBox("何だ、俺を通ろうってのか？\n無理だっての、やめてくれ！", "アーチ");
                  break;
                case 2:
                  ddddd_MessageBox("イテテテ、無理だって言ってるだろ！\nダイエットでもしてから来てくれ！", "アーチ");
                  break;
                case 1:
                  ddddd_MessageBox("……マジか？マジなのかコイツ！？\n誰かッ、助けてくれーーッ！", "アーチ");
                  break;
                case 0:
                  ddddd_MessageBox("ウボァー", "アーチ");
                  // 沈みアニメを行う
                  sunk = 2;
                  for (int i = 0; i < 24; i++) {
                    redraw(rw, objmap, floormap, di_tile, qvmap, move_x, move_y, overhalf);
                    SDL_Flip(rw);
                    SDL_Delay(5);
                  }
                  // TODO: 可能なら効果音を入れる事
                  // 外へ自動歩行させる
                  overhalf = true;
                  int adjust[] = adjust_overhalf(move_x, move_y);
                  move_x -= 2*adjust[1];
                  move_y -= 2*adjust[0];
                  for (int i = 0; i < 16; i++) {
                    move_x += prev_x;
                    move_y += prev_y;
                    redraw(rw, objmap, floormap, di_tile, qvmap, move_x, move_y, overhalf);
                    SDL_Flip(rw);
                    SDL_Delay(5);
                  }
                  // 画面をフェードアウトさせる
                  SDL_SetAlpha(rw, SDL_SRCALPHA, 255);
                  for (int i = 255; 0 <= i; i--) {
                    Uint32 c = SDL_MapRGBA(rw.format,
                        cast(Uint8)i,
                        cast(Uint8)i,
                        cast(Uint8)i,
                        cast(Uint8)i);
                    SDL_FillRect(rw, null, c);
                    SDL_Flip(rw);
                    SDL_Delay(10);
                  }
                  // TODO: あとで
                  // エピローグを出す
                  ddddd_MessageBox("外をうろついた。", "エピローグ");
                  ddddd_MessageBox("楽しかった。", "エピローグ");
                  ddddd_MessageBox("疲れた。", "エピローグ");
                  ddddd_MessageBox("家に帰って寝た。", "エピローグ");
                  ddddd_MessageBox("END", "エピローグ");
                  done = true;
                  break Loop;
                default:
                  throw new Error("assert");
                  break;
              }
            }
            else if ((collision[1] == 9) || (collision[1] == 10)) {
              // 棚
              MessageBeep(-1); // 仮
            }
            // TODO: ドア種別によってメッセージを変更する
            else {
              // ドア各種
              ddddd_MessageBox("これは人間用の通路だ。", "柱");
            }
          }
          // HP依存イベントを出す
          if (hp == 19) {
            event_occurred = true;
            ddddd_MessageBox("顔面から衝突した。痛い。", "柱");
          }
          else if (hp == 10) {
            event_occurred = true;
            ddddd_MessageBox("ぶつかりすぎてヒビが入った。", "柱");
          }
          else if (hp == 5) {
            event_occurred = true;
            ddddd_MessageBox("ぶつかりすぎてボロボロだ。", "柱");
          }
          else if (hp == 1) {
            event_occurred = true;
            ddddd_MessageBox("兄貴ィーッ、もうっ、駄目だぁっ", "柱");
          }
          if (!event_occurred) {
            // イベント無し壁衝突だった
            // 衝突seを鳴らす(ダイアログが出た場合は鳴らさない必要がある)
            MessageBeep(-1);
          }
          collision = null; // 衝突情報をクリアする
        }
        // 値をクリアする
        prev_x = 0;
        prev_y = 0;
        move_x = 0;
        move_y = 0;
        overhalf = false;
      }
    }

    redraw(rw, objmap, floormap, di_tile, qvmap, move_x, move_y, overhalf);

    // 更新
    SDL_Flip(rw);
    SDL_Delay(5); /* TODO: あとでfpsが一定になるようにする事 */
    //timer++;

    if (!started) {
      started = true;
      ddddd_MessageBox("私は柱だ。", "プロローグ");
      ddddd_MessageBox("ちょっと外に遊びに行きたくなった。", "プロローグ");
      ddddd_MessageBox("(矢印キー/テンキー/hjklyubnで移動できます)", "説明");
    }
  }

  ddddd_term();
  return 0; /* main_of_mains()は0が正常終了 */
}

void redraw(SDL_Surface *rw,
    byte*[][] objmap, byte*[][] floormap, SDL_Surface *[] di_tile,
    SDL_Surface *qvmap, int move_x, int move_y, bool overhalf)
{
  // qv上のカーソルの位置を算出する
  int loc[2] = ddddd_qv_rotate45_location(p_x*3+1, p_y*3+1, objmap.length*3);
  // qv表示
  redraw_map(floormap, objmap, di_tile, qvmap, move_x, move_y, loc, overhalf);
  //ddddd_MessageBox("loc[0]: "~toString(loc[0]));
  //ddddd_MessageBox("loc[1]: "~toString(loc[1]));
  SDL_Rect dst;
  //dst.x = cast(Sint16)(rw.w/2 - qvmap.w/2);
  //dst.y = cast(Sint16)(rw.h/2 - qvmap.h/2);
  // TODO: おそらく、QVMAP_PADDINGを抜く挙動が抜けている？
  dst.x = cast(Sint16)(rw.w/2 - loc[1]*TILE_WIDTH/2 - move_x*2 - TILE_WIDTH/2);
  dst.y = cast(Sint16)(rw.h/2 - loc[0]*TILE_HEIGHT/2 - move_y - TILE_HEIGHT/2 - QVMAP_PADDING/2);
  SDL_FillRect(rw, null, SDL_MapRGB(rw.format, 0, 0, 0));
  SDL_BlitSurface(qvmap, null, rw, &dst);
  return;
}

void redraw_map(byte*[][] floormap, byte*[][] objmap,
    SDL_Surface *[] di_tile, SDL_Surface *qvmap, int move_x, int move_y,
    int[] loc, bool overhalf)
{
  if (sunk) sunk_level++;
  int map_height = floormap.length;
  int map_width = floormap[0].length;
  int qv_size = ddddd_qv_rotate45_size(cast(void*[][])floormap);
  int adjust[2] = [ 0, 0 ];
  if (overhalf) {
    adjust[] = adjust_overhalf(move_x, move_y);
  }
  /*ddddd_MessageBox(
      "loc[1]: " ~ toString(loc[1])
      ~
      "\nloc[0]: " ~ toString(loc[0]));*/
  // 画面をクリアする
  SDL_FillRect(qvmap, null, SDL_MapRGB(qvmap.format, 0, 0, 0));
  // floormapを反映する
  byte*[][] qv_floor = cast(byte*[][])ddddd_qv_rotate45_map(cast(void*[][])floormap);
  for (int y = 0; y < qv_size; y++) {
    for (int x = 0; x < qv_size; x++) {
      if (!qv_floor[y][x]) continue;
      byte *data = qv_floor[y][x];
      DIInfo *diinfo = get_rect_of_floor(data[1]);
      if (!diinfo) continue;
      SDL_Rect dst;
      dst.x = cast(Sint16)(x*TILE_WIDTH/2 - diinfo.coordinate_x);
      dst.y = cast(Sint16)(y*TILE_HEIGHT/2 - diinfo.coordinate_y + QVMAP_PADDING);
      SDL_BlitSurface(di_tile[data[0]], diinfo.rect, qvmap, &dst);
    }
  }
  // (必要なら)カーソルを反映する
  // TODO: あとで
  // objmapを反映する
  // TODO: キャラクタもこの時点で同時に反映させる必要がある(あとで)
  // TODO: あとで
  byte*[][] qv_obj = cast(byte*[][])ddddd_qv_rotate45_map(triplicate_map(cast(void*[][])objmap));
  //ddddd_MessageBox("qv_floor[4].length: " ~ toString(qv_floor[4].length));
  for (int y = 0; y < qv_size; y++) {
    for (int x = 0; x < qv_size; x++) {
      // TODO: qv上で右下方向に移動する際に、右上の壁の方が優先されて
      //       表示されてしまう場合がある。対策を考える事。
      //       (左上移動時に、左下に壁がある場合も再現)
      if ((loc[1]+adjust[1] == x) && (loc[0]+adjust[0] == y)) {
        // キャラクタを表示する
        //DIInfo *diinfo = get_rect_of_floor(13);
        DIInfo *diinfo = get_rect_of_pillar(16);
        SDL_Rect dst;
        dst.x = cast(Sint16)(x*TILE_WIDTH/2 - diinfo.coordinate_x + move_x*2);
        dst.y = cast(Sint16)(y*TILE_HEIGHT/2 - diinfo.coordinate_y + QVMAP_PADDING + move_y*1);
        if (sunk == 1) {
          if ((sunk_level*4 < diinfo.rect.h)) {
            diinfo.rect.h -= sunk_level*4;
            diinfo.coordinate_y -= sunk_level*4;
            dst.y += sunk_level*4;
            SDL_BlitSurface(di_tile[IMG_PILLARS], diinfo.rect, qvmap, &dst);
          }
        }
        else {
          SDL_BlitSurface(di_tile[IMG_PILLARS], diinfo.rect, qvmap, &dst);
        }
      }
      if (qv_obj[y][x]) {
        byte *data = qv_obj[y][x];
        DIInfo *diinfo;
        if (data[0] == IMG_PILLARS) {
          diinfo = get_rect_of_pillar(data[1]);
        }
        else if (data[0] == IMG_WALLS) {
          diinfo = get_rect_of_wall(data[1]);
        }
        else if (data[0] == IMG_DOORS) {
          diinfo = get_rect_of_door(data[1]);
        }
        else {
          throw new Error("assert");
        }
        if (diinfo) {
          SDL_Rect dst;
          dst.x = cast(Sint16)(x*TILE_WIDTH/2 - diinfo.coordinate_x);
          dst.y = cast(Sint16)(y*TILE_HEIGHT/2 - diinfo.coordinate_y + QVMAP_PADDING);
          if ((sunk == 2) && (data[0] == IMG_DOORS) && ((data[1] == 7) || (data[1] == 8))) {
            if ((sunk_level*4 < diinfo.rect.h)) {
              diinfo.rect.h -= sunk_level*4;
              diinfo.coordinate_y -= sunk_level*4;
              dst.y += sunk_level*4;
              SDL_BlitSurface(di_tile[data[0]], diinfo.rect, qvmap, &dst);
            }
          }
          else {
            SDL_BlitSurface(di_tile[data[0]], diinfo.rect, qvmap, &dst);
          }
        }
      }
    }
  }

  return;
}

int []adjust_overhalf(int move_x, int move_y)
{
  int adjust_overhalf_y = 0;
  int adjust_overhalf_x = 0;
  if (move_y < 0) {
    // 上
    adjust_overhalf_y = -1;
    if (move_x < 0) adjust_overhalf_x = -1; // 左上
    if (0 < move_x) adjust_overhalf_x = 1; // 右上
    if (move_x == 0) adjust_overhalf_y = -2; // 真上
  }
  else if (0 < move_y) {
    // 下
    adjust_overhalf_y = 1;
    if (move_x < 0) adjust_overhalf_x = -1; // 左下
    if (0 < move_x) adjust_overhalf_x = 1; // 右下
    if (move_x == 0) adjust_overhalf_y = 2; // 真下
  }
  else {
    // 横
    if (move_x < 0) adjust_overhalf_x = -2; // 左
    if (0 < move_x) adjust_overhalf_x = 2; // 右
  }
  return [ adjust_overhalf_y, adjust_overhalf_x ];
}

/* 0 1 2
   3 4 5
   6 7 8
   が
   3 0 1
   6 4 2
   7 8 5
   になるので、逆の場合は
   1 2 5
   0 4 8
   3 6 7
   になる
 */
static const int key_rotate45_table[] = [ 3, 0, 1, 6, 4, 2, 7, 8, 5 ];
//static const int key_rotate45_table[] = [ 1, 2, 5, 0, 4, 8, 3, 6, 7 ];
void key_rotate45rev(int *x_ptr, int *y_ptr)
{
  if (!*x_ptr && !*y_ptr) return;
  /* *x_ptrと*y_ptrの範囲は-1から1に限定する */
  int src = (*x_ptr+1)+(*y_ptr+1)*3;
  int result = key_rotate45_table[src];
  *x_ptr = (result % 3) - 1;
  *y_ptr = (result / 3) - 1;
  return;
}


/* vim:set ft=d sw=2 ts=8 sts=2 et cindent: */
