/* $Id$ */

/* win32apiのダイアログ(または、それのエミュレーション)を出す為のモジュール */

module ddddd.dialog;

/* TODO: 非windows環境での動作が必要になった段階で、
 *       ものすごく適当にエミュレーションする為のコードを書く事
 */

public import ddddd.importer.public_;
private import ddddd.importer.private_;

public:

/* windows.h由来の定数定義を非windows環境でも使えるように、ここに持ってくる
 * ( came from dmd/src/phobos/std/c/windows/windows.d )
 */
/*
 * MessageBox() Flags
 */
enum
{
	MB_OK =                       0x00000000,
	MB_OKCANCEL =                 0x00000001,
	MB_ABORTRETRYIGNORE =         0x00000002,
	MB_YESNOCANCEL =              0x00000003,
	MB_YESNO =                    0x00000004,
	MB_RETRYCANCEL =              0x00000005,


	MB_ICONHAND =                 0x00000010,
	MB_ICONQUESTION =             0x00000020,
	MB_ICONEXCLAMATION =          0x00000030,
	MB_ICONASTERISK =             0x00000040,


	MB_USERICON =                 0x00000080,
	MB_ICONWARNING =              MB_ICONEXCLAMATION,
	MB_ICONERROR =                MB_ICONHAND,


	MB_ICONINFORMATION =          MB_ICONASTERISK,
	MB_ICONSTOP =                 MB_ICONHAND,

	MB_DEFBUTTON1 =               0x00000000,
	MB_DEFBUTTON2 =               0x00000100,
	MB_DEFBUTTON3 =               0x00000200,

	MB_DEFBUTTON4 =               0x00000300,


	MB_APPLMODAL =                0x00000000,
	MB_SYSTEMMODAL =              0x00001000,
	MB_TASKMODAL =                0x00002000,

	MB_HELP =                     0x00004000, // Help Button


	MB_NOFOCUS =                  0x00008000,
	MB_SETFOREGROUND =            0x00010000,
	MB_DEFAULT_DESKTOP_ONLY =     0x00020000,


	MB_TOPMOST =                  0x00040000,
	MB_RIGHT =                    0x00080000,
	MB_RTLREADING =               0x00100000,


	MB_TYPEMASK =                 0x0000000F,
	MB_ICONMASK =                 0x000000F0,
	MB_DEFMASK =                  0x00000F00,
	MB_MODEMASK =                 0x00003000,
	MB_MISCMASK =                 0x0000C000,
}

enum
{
/*
 * Dialog Box Command IDs
 */
	IDOK =                1,
	IDCANCEL =            2,
	IDABORT =             3,
	IDRETRY =             4,
	IDIGNORE =            5,
	IDYES =               6,
	IDNO =                7,

	IDCLOSE =         8,
	IDHELP =          9,


// end_r_winuser



/*
 * Control Manager Structures and Definitions
 */



// begin_r_winuser

/*
 * Edit Control Styles
 */
	ES_LEFT =             0x0000,
	ES_CENTER =           0x0001,
	ES_RIGHT =            0x0002,
	ES_MULTILINE =        0x0004,
	ES_UPPERCASE =        0x0008,
	ES_LOWERCASE =        0x0010,
	ES_PASSWORD =         0x0020,
	ES_AUTOVSCROLL =      0x0040,
	ES_AUTOHSCROLL =      0x0080,
	ES_NOHIDESEL =        0x0100,
	ES_OEMCONVERT =       0x0400,
	ES_READONLY =         0x0800,
	ES_WANTRETURN =       0x1000,

	ES_NUMBER =           0x2000,


// end_r_winuser



/*
 * Edit Control Notification Codes
 */
	EN_SETFOCUS =         0x0100,
	EN_KILLFOCUS =        0x0200,
	EN_CHANGE =           0x0300,
	EN_UPDATE =           0x0400,
	EN_ERRSPACE =         0x0500,
	EN_MAXTEXT =          0x0501,
	EN_HSCROLL =          0x0601,
	EN_VSCROLL =          0x0602,


/* Edit control EM_SETMARGIN parameters */
	EC_LEFTMARGIN =       0x0001,
	EC_RIGHTMARGIN =      0x0002,
	EC_USEFONTINFO =      0xffff,




// begin_r_winuser

/*
 * Edit Control Messages
 */
	EM_GETSEL =               0x00B0,
	EM_SETSEL =               0x00B1,
	EM_GETRECT =              0x00B2,
	EM_SETRECT =              0x00B3,
	EM_SETRECTNP =            0x00B4,
	EM_SCROLL =               0x00B5,
	EM_LINESCROLL =           0x00B6,
	EM_SCROLLCARET =          0x00B7,
	EM_GETMODIFY =            0x00B8,
	EM_SETMODIFY =            0x00B9,
	EM_GETLINECOUNT =         0x00BA,
	EM_LINEINDEX =            0x00BB,
	EM_SETHANDLE =            0x00BC,
	EM_GETHANDLE =            0x00BD,
	EM_GETTHUMB =             0x00BE,
	EM_LINELENGTH =           0x00C1,
	EM_REPLACESEL =           0x00C2,
	EM_GETLINE =              0x00C4,
	EM_LIMITTEXT =            0x00C5,
	EM_CANUNDO =              0x00C6,
	EM_UNDO =                 0x00C7,
	EM_FMTLINES =             0x00C8,
	EM_LINEFROMCHAR =         0x00C9,
	EM_SETTABSTOPS =          0x00CB,
	EM_SETPASSWORDCHAR =      0x00CC,
	EM_EMPTYUNDOBUFFER =      0x00CD,
	EM_GETFIRSTVISIBLELINE =  0x00CE,
	EM_SETREADONLY =          0x00CF,
	EM_SETWORDBREAKPROC =     0x00D0,
	EM_GETWORDBREAKPROC =     0x00D1,
	EM_GETPASSWORDCHAR =      0x00D2,

	EM_SETMARGINS =           0x00D3,
	EM_GETMARGINS =           0x00D4,
	EM_SETLIMITTEXT =         EM_LIMITTEXT, /* ;win40 Name change */
	EM_GETLIMITTEXT =         0x00D5,
	EM_POSFROMCHAR =          0x00D6,
	EM_CHARFROMPOS =          0x00D7,



// end_r_winuser


/*
 * EDITWORDBREAKPROC code values
 */
	WB_LEFT =            0,
	WB_RIGHT =           1,
	WB_ISDELIMITER =     2,

// begin_r_winuser

/*
 * Button Control Styles
 */
	BS_PUSHBUTTON =       0x00000000,
	BS_DEFPUSHBUTTON =    0x00000001,
	BS_CHECKBOX =         0x00000002,
	BS_AUTOCHECKBOX =     0x00000003,
	BS_RADIOBUTTON =      0x00000004,
	BS_3STATE =           0x00000005,
	BS_AUTO3STATE =       0x00000006,
	BS_GROUPBOX =         0x00000007,
	BS_USERBUTTON =       0x00000008,
	BS_AUTORADIOBUTTON =  0x00000009,
	BS_OWNERDRAW =        0x0000000B,
	BS_LEFTTEXT =         0x00000020,

	BS_TEXT =             0x00000000,
	BS_ICON =             0x00000040,
	BS_BITMAP =           0x00000080,
	BS_LEFT =             0x00000100,
	BS_RIGHT =            0x00000200,
	BS_CENTER =           0x00000300,
	BS_TOP =              0x00000400,
	BS_BOTTOM =           0x00000800,
	BS_VCENTER =          0x00000C00,
	BS_PUSHLIKE =         0x00001000,
	BS_MULTILINE =        0x00002000,
	BS_NOTIFY =           0x00004000,
	BS_FLAT =             0x00008000,
	BS_RIGHTBUTTON =      BS_LEFTTEXT,



/*
 * User Button Notification Codes
 */
	BN_CLICKED =          0,
	BN_PAINT =            1,
	BN_HILITE =           2,
	BN_UNHILITE =         3,
	BN_DISABLE =          4,
	BN_DOUBLECLICKED =    5,

	BN_PUSHED =           BN_HILITE,
	BN_UNPUSHED =         BN_UNHILITE,
	BN_DBLCLK =           BN_DOUBLECLICKED,
	BN_SETFOCUS =         6,
	BN_KILLFOCUS =        7,

/*
 * Button Control Messages
 */
	BM_GETCHECK =        0x00F0,
	BM_SETCHECK =        0x00F1,
	BM_GETSTATE =        0x00F2,
	BM_SETSTATE =        0x00F3,
	BM_SETSTYLE =        0x00F4,

	BM_CLICK =           0x00F5,
	BM_GETIMAGE =        0x00F6,
	BM_SETIMAGE =        0x00F7,

	BST_UNCHECKED =      0x0000,
	BST_CHECKED =        0x0001,
	BST_INDETERMINATE =  0x0002,
	BST_PUSHED =         0x0004,
	BST_FOCUS =          0x0008,


/*
 * Static Control Constants
 */
	SS_LEFT =             0x00000000,
	SS_CENTER =           0x00000001,
	SS_RIGHT =            0x00000002,
	SS_ICON =             0x00000003,
	SS_BLACKRECT =        0x00000004,
	SS_GRAYRECT =         0x00000005,
	SS_WHITERECT =        0x00000006,
	SS_BLACKFRAME =       0x00000007,
	SS_GRAYFRAME =        0x00000008,
	SS_WHITEFRAME =       0x00000009,
	SS_USERITEM =         0x0000000A,
	SS_SIMPLE =           0x0000000B,
	SS_LEFTNOWORDWRAP =   0x0000000C,

	SS_OWNERDRAW =        0x0000000D,
	SS_BITMAP =           0x0000000E,
	SS_ENHMETAFILE =      0x0000000F,
	SS_ETCHEDHORZ =       0x00000010,
	SS_ETCHEDVERT =       0x00000011,
	SS_ETCHEDFRAME =      0x00000012,
	SS_TYPEMASK =         0x0000001F,

	SS_NOPREFIX =         0x00000080, /* Don't do "&" character translation */

	SS_NOTIFY =           0x00000100,
	SS_CENTERIMAGE =      0x00000200,
	SS_RIGHTJUST =        0x00000400,
	SS_REALSIZEIMAGE =    0x00000800,
	SS_SUNKEN =           0x00001000,
	SS_ENDELLIPSIS =      0x00004000,
	SS_PATHELLIPSIS =     0x00008000,
	SS_WORDELLIPSIS =     0x0000C000,
	SS_ELLIPSISMASK =     0x0000C000,


// end_r_winuser


/*
 * Static Control Mesages
 */
	STM_SETICON =         0x0170,
	STM_GETICON =         0x0171,

	STM_SETIMAGE =        0x0172,
	STM_GETIMAGE =        0x0173,
	STN_CLICKED =         0,
	STN_DBLCLK =          1,
	STN_ENABLE =          2,
	STN_DISABLE =         3,

	STM_MSGMAX =          0x0174,
}




int ddddd_MessageBox(char[] text, char[] title = null, SDL_syswm.UINT uType = MB_OK | MB_APPLMODAL) {
  version (Win32) {
    char *text_true = text ? toStringz(utf8_sjis(text)) : null;
    char *title_true = title ? toStringz(utf8_sjis(title)) : null;
    return MessageBoxA(cast(HANDLE)ddddd_rw_hwnd, text_true, title_true, cast(std.c.windows.windows.UINT)uType);
  }
  else {
    throw new Error("not implemented");
  }
}


/* vim:set ft=d sw=2 ts=8 sts=2 et cindent: */
