/* $Id$ */

/* 画像操作関連のモジュール */


module ddddd.image;

public import ddddd.importer.public_;
private import ddddd.importer.private_;


public:


Uint32 ddddd_getPixel(SDL_Surface *surface, int x, int y)
{
  int bpp = surface.format.BytesPerPixel;
  /* この p は取得したいピクセルを指すアドレス */
  Uint8 *p = cast(Uint8 *)surface.pixels + y * surface.pitch + x * bpp;

  switch(bpp) {
    case 1:
      return *p;

    case 2:
      return *cast(Uint16 *)p;

    case 3:
      if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
        return p[0] << 16 | p[1] << 8 | p[2];
      else
        return p[0] | p[1] << 8 | p[2] << 16;

    case 4:
      return *cast(Uint32 *)p;

    default:
      return 0;
  }
  return 0;
}

struct RGBAMask {
  Uint32 r;
  Uint32 g;
  Uint32 b;
  Uint32 a;
};

private static RGBAMask *_mask = null;
RGBAMask *ddddd_get_rgbamask()
{
  if (_mask) return _mask;
  _mask = new RGBAMask;
  /* SDL は 個々のピクセルを 32 ビットの数値として解釈するので、
   * マスクは各マシンのエンディアン(バイトの並び)に依存しなければいけません */
  if (SDL_BYTEORDER == SDL_BIG_ENDIAN) {
    _mask.r = 0xff000000;
    _mask.g = 0x00ff0000;
    _mask.b = 0x0000ff00;
    _mask.a = 0x000000ff;
  } else {
    _mask.r = 0x000000ff;
    _mask.g = 0x0000ff00;
    _mask.b = 0x00ff0000;
    _mask.a = 0xff000000;
  }
  return _mask;
}


/* vim:set ft=d sw=2 ts=8 sts=2 et cindent: */
