/* $Id$ */

/* メッセージウィンドウを実現する為のモジュール */

/* TODO: ddddd.textareaを使うように再実装する事 */
/* 仕様:
   - ttfフォントを一種類のみ利用できる。
   -- その他の画像等を含める事は行わない(少なくとも、今のところは)
   -- 途中でフォントを変更したりは、今のところは仕様外とする。
      (可能かも知れないが、意図して実装はしない、まだ)
   - 指定されたサーフィスに対し、文字を表示させるだけとする。
   -- 背景やウィンドウの枠が欲しい場合は、別途、このウィンドウのうしろに
      自分で用意する必要がある。
   -- キー入力待ち状態になった時のウェイトシンボルの表示も、
      このモジュールでは面倒は見ない。
   - いくつかの組み込みの制御コードを持つ。
   -- 仕様はまだ未定。
   -- とりあえず「\r」はnop、「\n」は改行とする。
   - バックログは保持しない。よって、スクロール戻しは不可能。
   -- 実際には、実サーフィスをそのままスクロールさせている。
   - このメッセージウィンドウ自体の表示/非表示については、
     このモジュールでは管理しない。
     (というか、表示時も、単にblt転送するだけ)
*/


/* TODO: まず、必要最小限の実装を行う事 */
/* TODO: スクロール不要/禁則処理不要のメッセージウィンドウも
 *       実現可能にする必要がある(ステータスウィンドウ等の用途)
 *       (しかし、あとで)
 */
/* TODO: 文字列からマルチバイト文字を考慮しつつ、
         一文字ずつ切り出す処理が必要。考える事 */
/* TODO: 簡単な制御コードを実装する必要がある。
 * - \rは何もしない
 * - \nは改行
 * - (未定)は改ページ(と改ページアクション待ち)
 * - (未定)はウェイト
 * - 他には？？？
 * - BGM変更等の処理も入れるべきか？
 * -- おそらく不要。但し、バッファとコードの同期を取りたい場面はある筈なので、
 *    何らかの同期を取る為の制御コード自体は必要。
 *    (BGM変更等は、同期処理用の制御コードがあれば実現できる)
 */

module ddddd.msgwindow;

public import ddddd.importer.public_;
private import ddddd.importer.private_;
private import ddddd.image;
private import ddddd.textarea;

public:

struct MsgWindow {
  /* 以下は、必要最小限、実装するもの */
  SDL_Surface *surface; // メッセージウィンドウ本体のサーフィス
  Uint32 bgcolor; // 背景色(SDL_MapRGBA()の返り値)
  TTF_Font *font; // フォント
  int locate_x; // 次の文字を描画する為のx座標(ドット単位)
  int locate_y; // 次の文字を描画する為のy座標(ドット単位)
  int line_space; // 行間のドット数
  char[][] msgqueue = []; // まだ画面に表示されていないバッファ領域
  int is_waiting; // スクロール待ち等のクリック待ちフラグ(これが有効な間はwait_timerが0になっても先に進まない)
  int wait_timer; // 次の文字表示の為のウェイトタイマー(0になったら次を表示)
  int char_step; // 1文字を出力するのに費すデフォルトのステップ数(1文字出力後、この数だけ自動的にwait_timerが増える)
  int scroll_timer; // スクロール途中の状態(0%=0, 100%=255)
  int scroll_step; // 一行をスクロールさせるのに費すデフォルトのステップ数

  /* 以下は、あとで実装するもの */
  /*
  // 自動折り返しを行うか等の、ウィンドウの性質を決めるフラグ各種
  // TODO: あとでenumで定義する事
  int flags;
  */
};

// TODO: 引数を考える
MsgWindow *ddddd_mw_create(
    int width,
    int height,
    Uint32 bgcolor,
    TTF_Font font,
    ) {
  MsgWindow *mw = new MsgWindow;
  RGBAMask *m = ddddd_get_rgbamask();
  mw.surface = SDL_CreateRGBSurface(0, width, height, ddddd_rw_depth, m.r, m.g, m.b, m.a);
  // TODO: あとで
  ddddd_mw_clear(mw);
  return mw;
}


void ddddd_mw_clear(MsgWindow *mw) {
  mw.locate_x = 0;
  mw.locate_y = 0;
  mw.wait_timer = 0;
  mw.is_waiting = 0;
  SDL_FillRect(mw.surface, null, mw.bgcolor);
  return;
}

/* 他に必要な手続き:
 * - メッセージウィンドウをblt転送(？)
 * - メッセージウィンドウ自体を更新(？)
 * - メッセージウィンドウに文字列をバッファリングさせる
 * - メッセージウィンドウをn単位だけ進める(スクロール等)
 * - メッセージウィンドウがクリック待ちかどうか調べる
 * - メッセージウィンドウのクリック待ちを解除して進める
 * - メッセージウィンドウを破棄(SDL_FreeSurface等を行う)
 */


/* vim:set ft=d sw=2 ts=8 sts=2 et cindent: */
